// data una lista ne calcola la lunghezza (mysize)

// O(n)
def mysize(l:List[Int]):Int = {
	if (l==Nil) 0 
	else 1+mysize(l.tail)
}

// O(n^2)
def mysize2(l:List[Int]):Int = {
	if (l==Nil) 0 
	else 1+mysize2(l.init)
}

// data una lista, verifica se è palindroma
// es: List(1,2,3,2,1) è palindroma
// idea: la lista è uguale alla sua versione rovesciata
def palindroma(l:List[Int]):Boolean = {
	l == l.reverse
}

// calcola gli elementi distinti usando groupBy
def mydistinct(l:List[Int]) = {
	val p = l.groupBy(identity).toList
	p.map(coppia => coppia._1)
}

// variante
def mydistinct2(l:List[Int]) = 	l.groupBy(identity).toList.map(_._1)
